#!/usr/bin/python
#coding=utf-8

import json
import os, sys
from PyQt5 import QtGui, QtWidgets, QtCore
import designer


class SchaduleStruct():
    def __init__(self):
        self.pt_id = ""
        self.pt_name = ""
        self.mode = ""
        self.week = ""
        self.date_preiod = []
        self.update_time = ""

class ProgramStruct():
    def __init__(self):
        self.p_id = ""
        self.p_name = ""
        self.start_time = ""
        self.emd_time = ""
        self.width = ""
        self.height = ""
        self.update_time = ""
        self.scene = []

class SceneStruct():
    def __init__(self):
        self.s_id = ""
        self.background_color = ""
        self.background_image = ""
        self.audio_url = ""
        self.play_time  = ""
        self.control = []

class ControlStruct():
    def __init__(self):
        self.c_id = ""
        self.type = ""
        self.xpos = ""
        self.ypos = ""
        self.zpos = ""
        self.width = ""
        self.height = ""
        self.update_time = ""
        #self.special = []
        #self.material = []

        self.i_id = ""
        self.i_url = ""

        self.switch_time = ""
        self.font_content = ""
        self.font_size = ""
        self.font_color = ""
        self.font_style = ""
        self.align = ""
        self.play_speed = ""
        self.play_type = ""
        self.background_transparent = ""
        self.jump_url = ""

class MaterialStruct():
    def __init__(self):
        self.i_id = ""
        self.i_url = ""
        


class SpecialStruct():
    def __init__(self):
        self.switch_time = ""
        self.font_content = ""
        self.font_size = ""
        self.font_color = ""
        self.font_style = ""
        self.align = ""
        self.play_speed = ""
        self.play_type = ""
        self.background_transparent = ""
        self.jump_url = ""

def analycfg(data, programlist = []):

    print('analycfg......')
    app = QtWidgets.QApplication(sys.argv)
    Schadule = SchaduleStruct()
    dict_json = json.loads(data)
    if dict_json.get('code') == 0:
            
        json_data = dict_json.get('data')
        if isinstance(json_data, list):
            #print(len(json_data))
            Schadule.pt_id       = json_data[0].get('pt_id')
            Schadule.pt_name     = json_data[0].get('pt_name')
            Schadule.mode        = json_data[0].get('mode')
            Schadule.week        = json_data[0].get('week')
            Schadule.date_period = json_data[0].get('date_period')
            Schadule.update_time = json_data[0].get('update_time')
            
            #print(Schadule.pt_id)
            programlist.append(Schadule)
            json_pros = json_data[0].get('programs')
            if isinstance(json_pros, list):
                print('program num:', len(json_pros))
                for i in range(len(json_pros)):
                    
                    program = ProgramStruct()
                    program.p_id        = json_pros[i].get('p_id')
                    program.p_name      = json_pros[i].get('p_name')
                    program.start_time  = json_pros[i].get('start_time')
                    program.end_time    = json_pros[i].get('end_time')
                    program.width       = json_pros[i].get('width')
                    program.height      = json_pros[i].get('height')
                    program.update_time = json_pros[i].get('update_time')
                    program.scene       = json_pros[i].get('scene')
                    
                    programlist.append(program)
                    widget = designer.MyWidget(program)
                    json_pro = json_pros[i]
                    json_scene = json_pros[i].get('scene')
                    
                    if isinstance (json_scene, list):

                        for j in range(len(json_scene)):

                            print('j == ', j)
                            scene = SceneStruct()
                            scene.s_id             = json_scene[j].get('s_id')
                            scene.audio_url        = json_scene[j].get('audio_url')
                            scene.background_color = json_scene[j].get('background_color')
                            scene.background_image = json_scene[j].get('background_image')
                            scene.play_time        = json_scene[j].get('play_time')
                            scene.control          = json_scene[j].get('control')
                            json_control = json_scene[j].get('control')
                            programlist.append(scene)
                            widget.setAttribute(scene)
                            #print(scene.s_id)
                            if isinstance (json_control, list):
                                
                                for n in range(len(json_control)):

                                    print('n == ', n)
                                    control = ControlStruct()
                                    control.c_id        = json_control[n].get('c_id')
                                    control.type        = json_control[n].get('type')
                                    control.xpos        = json_control[n].get('xpos')
                                    control.ypos        = json_control[n].get('ypos')
                                    control.zpos        = json_control[n].get('zpos')
                                    control.width       = json_control[n].get('width')
                                    control.height      = json_control[n].get('height')
                                    control.update_time = json_control[n].get('update_time')
                                    #for key in json_control[n]:
                                     #   if hasattr(control, key):
                                      #      setattr(control, key, json_control[n])
                                       # else:
                                        #    print('not have this attribult')
                                    #print(control.type)
                                    json_material = json_control[n].get('material')
                                    json_special = json_control[n].get('special')
                                    if isinstance (json_material, list):

                                        if len(json_material) == 0:
                                            print("material no have sources")
                                        else:
                                            for s in range(len(json_material)):
                                                
                                            control.i_id = json_material[s].get('i_id')
                                            control.i_url = json_material[s].get('i_url')
                                            
                                    if isinstance (json_special, dict):
                                        
                                        control.switch_time            = json_special.get('switch_time')
                                        control.font_content           = json_special.get('font_content')
                                        control.font_size              = json_special.get('font_size')
                                        control.font_color             = json_special.get('font_color')
                                        control.font_style             = json_special.get('font_style')
                                        control.align                  = json_special.get('align')
                                        control.play_speed             = json_special.get('play_speed')
                                        control.play_type              = json_special.get('play_type')
                                        control.background_transparent = json_special.get('background_transparent')
                                        control.jump_url               = json_special.get('jump_url')
                                    #print(control.font_size)
                                    programlist.append(control)
                                        
                                    if json_control[n].get('type') == 'text':
                                        print('type:text')
                                        print('c_id = ', control.c_id)
                                        text = designer.MyText(widget, control)     
                                        
                                    if json_control[n].get('type') == 'image':
                                        print('type:image')
                                        print('c_id = ', control.c_id)
                                        image = designer.MyImage(widget, control)
                                        
                                    if json_control[n].get('type') == 'video':
                                        print('type:video')
                                        print('c_id = ', control.c_id)
                                        video = designer.MyVideo(control)
                                        
                                    if json_control[n].get('type') == 'date-time':
                                        datetime = designer.MyDateTime(widget, control)


                                    if json_control[n].get('type') == 'weather-city':
                                        weather = designer.MyWeather(widget, control)

                                    #else:
                                        #print('no have this type')
                                

                                #n + 1

                        #j + 1
                            

                    #i + 1
                    
                widget.show()
                
    sys.exit(app.exec_())
    return True

    

def analyjson(json_obj):

    for key,value in json_obj.items():
        if isinstance(value, list):
            for val in value:
                #print(val)
                analyjson(val)
        elif isinstance(value, dict):
            analyjson(value)
        else:
            Programdict.setdefault(key, value)
            #print(key, '===', value)
        #return Programdict

# traversing the json data
def Traverse(json_obj):
    
    for key,value in json_obj.items():
        if isinstance(value, list):
            for val in value:
                #print(val)
                Traverse(val)
        elif isinstance(value, dict):
            Traverse(value)
        else:
            print(key, '===', value)
        #return 'ok'




#if __name__ == '__main__':

    
    #programlist = []
    #Programdict = {}
    #filename = "/home/loongson/InfoPublish/config.json"
        
    #with open(filename, 'r', encoding='utf-8') as file:
        #data = json.load(file)
        #analycfg(data)

    #for i in range(len(programlist)):
        #print("serial number: %s  value: %s" & (i + 1, list[i]))
        
    













        


        
