#!/usr/bin/python

import os
import sys
from PyQt5 import QtGui, QtWidgets, QtCore
from PyQt5.QtCore import Qt
from PyQt5.QtGui import QPalette, QBrush, QPixmap, QImage, QFont, QColor
import subprocess
import AnalyCfg
import AnalyPtConf


class MyWidget(QtWidgets.QWidget):
    
    def __init__(self, ProgramStruct, parent=None):
        
        super(MyWidget, self).__init__(parent)
        self.MyProgram = ProgramStruct
        #self.setWindowFlags(Qt.FramelessWindowHint)
        #self.resize(1024, 768)
        #self.showMaximized()
        self.drawn(self.MyProgram)
            
    def initUI(self):
        
        #self.setGeometry(300, 300, 300, 300)
        self.setWindowIcon(QIcon('1.png'))
        self.setWindowFlages(Qt.FramelessWindowHint)

    def drawn(self, ProgramStruct):
        
        print(ProgramStruct.width)
        print(ProgramStruct.height)
        self.desktop = QtWidgets.QApplication.desktop()
        self.screenRect = self.desktop.screenGeometry()
        # get screen size
        #self.width = self.screenRect.width()
        #self.width = self.geometry().width()
        self.resize(int(ProgramStruct.width), int(ProgramStruct.height))
        self.setAutoFillBackground(True)

        
    def setAttribute(self, SceneStruct):

        ResourcesPath = '/home/loongson/InfoPublish/resources/'
        if SceneStruct is not None:
            
            self.palette = QPalette()
            if (SceneStruct.background_image is not None) or ((SceneStruct.background_image is not None)and(SceneStruct.background_color is not None)):
                ResourcesName = os.path.basename(SceneStruct.background_image)
                backgroundimage = ResourcesPath + ResourcesName
                self.palette.setBrush(QPalette.Background,
                                      QBrush(QPixmap
                                             ('/home/loongson/InfoPublish/bg.jpg').scaled
                                             (int(ProgramStruct.width), int(ProgramStruct.height),
                                              Qt.IgnoreAspectRatio)))
            if SceneStruct.background_color is not None:
                #color = int(SceneStruct.background_color.lstrip('#'), 16)
                #hex_color = hex(color)
                col = QColor(0, 0, 0)
                col.setNamedColor(SceneStruct.background_color)
            
                self.palette.setColor(QPalette.Background, col)  #QColor(205,115,154,0) | 0xff00ff

            self.setPalette(self.palette)


        
class MyText(QtWidgets.QWidget):
    
    def __init__(self, FatherForm, ControlStruct):
        
        super().__init__()
        self.MyControl = ControlStruct
        self.MyForm = FatherForm
        
        self.initUI(self.MyControl, self.MyForm)

    def initUI(self, ControlStruct, FatherForm):
        if ControlStruct is not None:

            font = QFont()
            #print(ControlStruct.xpos)
            #FatherForm.labeltxt = QtWidgets.QLabel(ControlStruct.font_content)
            LblText = QtWidgets.QLabel(FatherForm)
            LblText.setText(ControlStruct.font_content)
            LblText.setWordWrap(True)

            LblText.setGeometry(int(float(ControlStruct.xpos)), int(float(ControlStruct.ypos)),
                                  int(float(ControlStruct.width)), int(float(ControlStruct.height)))
            if ControlStruct.align == "left":
                LblText.setAlignment(QtCore.Qt.AlignLeft)
            elif ControlStruct.align == "right":
                LblText.setAlignment(QtCore.Qt.AlignRight)
            elif ControlStruct.align == "middle":
                LblText.setAlignment(QtCore.Qt.AlignCenter)

            if ControlStruct.font_style == "bold":
                font.setBold(True)  # jia cu
            elif ControlStruct.font_style == "underline":
                font.setUnderLine(True) # she zhi xiahuaxian
            elif ControlStruct.font_style == "italic":
                font.setItalic(True) # xie ti
                
            elif ControlStruct.font_style == "bold,underline" or ControlStruct.font_style == "underline,bold":
                font.setUnderLine(True) # she zhi xiahuaxian
                font.setBold(True)  # jia cu
            elif ControlStruct.font_style == "bold,italic" or ControlStruct.font_style == "italic,bold":
                font.setItalic(True) # xie ti
                font.setBold(True)  # jia cu
            elif ControlStruct.font_style == "underline,italic" or ControlStruct.font_style == "italic,underline":
                font.setItalic(True) # xie ti
                font.setUnderLine(True) # she zhi xiahuaxian
            elif ControlStruct.font_style == "bold,underline,italic" or ControlStruct.font_style == "bold,italic,underline" or ControlStruct.font_style == "underline,bold,italic" or ControlStruct.font_style == "underline,italic,bold" or ControlStruct.font_style == "italic,bold,underline" or ControlStruct.font_style == "italic,underline,bold":
                font.setBold(True)
                font.setItalic(True) 
                font.setUnderLine(True) 

            #font.setFamily(ControlStruct.font_family)
            
            LblText.setFont(font)   
            #FatherForm.labeltxt.setStyleSheet("color:rgb(225, 22, 173, 255)")
            LblText.setStyleSheet("font_size:"+ControlStruct.font_size)
            if ControlStruct.font_color is not None:
                LblText.setStyleSheet("color:"+ControlStruct.font_color)
            if ControlStruct.background_transparent == "1":
                
                LblText.setStyleSheet("background:transparent")
            
            #self.labeltxt.setScaledContents(False)
            #FatherForm.layout = QtWidgets.QVBoxLayout()
            #FatherForm.layout.addWidget(LblText)
            #FatherForm.setLayout(FatherForm.layout)
            
        else:
            print('ControlStruct is null')



class MyImage(QtWidgets.QWidget):
    def __init__(self, FatherForm, ControlStruct):
        super().__init__()
        self.MyControl = ControlStruct
        self.MyForm = FatherForm
        self.initUI(self.MyControl, self.MyForm)

    def initUI(self, ControlStruct, FatherForm):

        lblimg = QtWidgets.QLabel(FatherForm)
        lblimg.setGeometry(int(ControlStruct.xpos), int(ControlStruct.ypos),
                           int(ControlStruct.width), int(ControlStruct.height))
        
        filename = os.path.basename(ControlStruct.i_url)
        loadaddr = "/home/loongson/InfoPublish/resources/" + filename
        print(ControlStruct.i_id)
        #pix = QPixmap('/home/loongson/InfoPublish/1.jpg')
        pix = QPixmap(loadaddr)
        print(loadaddr)
        lblimg.setPixmap(pix)
        
        lblimg.setScaledContents(True)
        FatherForm.layout1 = QtWidgets.QVBoxLayout()
        FatherForm.layout1.addWidget(lblimg)
        FatherForm.setLayout(FatherForm.layout1)


    def ChangeImage(self, ):

        filename = os.path.basename(i_url)
        

class MyVideo(QtWidgets.QWidget):
    
    def __init__(self, ControlStruct):
        super().__init__()
        self.MyControl = ControlStruct
        self.PlayerMovie(self.MyControl)

    def PlayerMovie(self, ControlStruct):

        VideoPath = '/home/loongson/InfoPublish/resources/'
        VideoName = os.path.basename(ControlStruct.i_url)
        VideoFile = VideoPath + VideoName
        print('Videoname : ', VideoName)
        print(ControlStruct.i_id)
        program = "mplayer -noborder -geometry "+str(ControlStruct.xpos)+":"+str(ControlStruct.ypos)+" -zoom -x "+str(ControlStruct.width)+" -y "+str(ControlStruct.height)+" -ontop "+VideoFile+" </dev/null > /dev/null 2>1&" 
        #result = subprocess.Popen("mplayer -noborder -geometry 362:47 -zoom -x 280 -y 260 -ontop iqy.mp4 </dev/null > /dev/null 2>1&",
                                  #shell=True,
                                  #stdout=subprocess.PIPE)
        result = subprocess.Popen(program, shell=True, stdout=subprocess.PIPE)
        print(program)
        if(result.poll == 0):
            print("succes")
            #result.communicate(input = "pause\n")
            #result.suspend()

        else:
            print("fail")
        

class MyWeather(QtWidgets.QWidget):
    def __init__(self, ControlStruct):
        super().__init__()
        self.MyControlStruct = ControlStruct
        self.initUI(self.MyControlStruct)

    def initUI(self, ControlStruct):        
        pix = QPixmap('/home/loongson/InfoPublish/1.jpg')
        lblimg = QtWidgets.QLabel(self)
        lblimg.setGeometry(x, y, w, h)
        lblimg.setPixmap(pix)
        lblimg.setScaledContents(True)
        self.layout1 = QtWidgets.QVBoxLayout()
        self.layout1.addWidget(lblimg)
        self.setLayout(self.layout1)


class MyDateTime(QtWidgets.QWidget):
    def __init__(self, ControlStruct):
        super(DateTimeEditDemo, self).__init__()
        self.MyControl = ControlStruct
        self.initUI(self.MyControl)

    def initUI(self, ControlStruct):
        self.setWindowTitle('QDateTimeEdit example')
        self.resize(300, 90)

        vlayout = QVBoxLayout()

        dateTimeEdit = QDateTimeEdit(QdateTime.currentDateTime(), self)

        dateTimeEdit.setDisplayFormat('yyyy/MM/dd HH:mm:ss')
        
        vlayout.addWidget(dateTimeEdit)
        self.setLayout(vlayout)


if __name__ == '__main__':

    # create a QApplication 
    app = QtWidgets.QApplication(sys.argv)

    result = AnalyCfg.ReadptConfig()
    print(result)
    #print(AnalyPtConf.ControlStruct.xpos)
    if result == True:
        
    #mainwindow = QMainwindow()
        widget = MyWidget()
    
    widget.show()
    sys.exit(app.exec_())
